package combinatorParser.comprehension;

object Grammar {

  import Parsers._;
  
  def Expr: Parser[int] =  
    for (val x <- Term;
         val xs <- rep { token('+') & Term }
        ) yield (x /: xs) ((x, y) => x + y);
  
  def Term: Parser[int] = 
    for (val x <- Factor;
         val xs <- rep { token('*') & Factor }
        ) yield (x /: xs) ((x, y) => x * y);
  
  def Factor: Parser[int] = 
    Number 
  | (for (val _ <- token('('); val x <- Expr; val _ <- token(')'))
     yield x);

  def Number: Parser[int] = 
    for (val chars <- token(Tokens.NUMBER)) yield Integer.parseInt(chars);
  
}

