package combinatorParser.comprehension;

object ParserTest extends AnyRef with Application {

  import Grammar._;
  import Tokens._;
  
  def test(in: List[Token]) = Expr(in) match {
    case Some(Pair(result, _)) =>
      Console.println("Parsed: " + result)
    case None => Console.println("Syntax error")
  }
  
  // ( 13 ) = 13
  test(List(
    Token('('),
    Token(13),
    Token(')')
  ));
  
  // 12 * ( 13 + 7 ) + 40 + 10 = 290
  test(List(
    Token(12),
    Token('*'),
    Token('('),
    Token(13),
    Token('+'),
    Token(7),
    Token(')'),
    Token('+'),
    Token(40),
    Token('+'),
    Token(10)
  ));
  
}
  