package combinatorParser.generic;

class GrammarEvaluator extends Grammar {

  def reduce(elems: List[Any]): List[Any] = elems match {
    case (x: int) :: "+" :: (y: int) :: xs => reduce((x + y) :: xs)
    case (x: int) :: "-" :: (y: int) :: xs => reduce((x - y) :: xs)
    case (x: int) :: "*" :: (y: int) :: xs => reduce((x * y) :: xs)
    case (x: int) :: "/" :: (y: int) :: xs => reduce((x / y) :: xs)
    case "(" :: x :: ")" :: Nil            => List(x)
    case (x: String) :: Nil                => List(Integer.parseInt(x))
    case xs                                => xs
  }
  
}

