package combinatorParser.generic;

object ParserTest extends AnyRef with Application {

  import Tokens._;
  
  val evaluator = new GrammarEvaluator;
  val printer = new GrammarPrinter;
  
  def decompose(msg: String, result: Parsers#Result): Unit = result match {
    case Some(Pair(List(result), _)) =>
      Console.println("msg: " + result)
    case None => Console.println("Syntax error")
  }
  
  def test(in: List[Token]) = {
    decompose("Term  = ", printer.Expr(in));
    decompose("Value = ", evaluator.Expr(in));
  }
  
  // ( 13 ) = 13
  test(List(
    Token('('),
    Token(13),
    Token(')')
  ));
  
  // 12 * ( 13 - 7 ) - 40 + 10 = 42
  test(List(
    Token(12),
    Token('*'),
    Token('('),
    Token(13),
    Token('-'),
    Token(7),
    Token(')'),
    Token('-'),
    Token(40),
    Token('+'),
    Token(10)
  ));
  
}
    
